DEFDBL A-Z
'                       MASS_GAL.BAS
'       Revision 1.0    Original                          28 Nov 1995
'       Revision 1.1    Corection massdisk & massdisk1    29 Dec 1995
'
DECLARE FUNCTION DISK# (r#)
DECLARE SUB PRINTTAB (posx#, num#)
DECLARE SUB READDATA ()

DIM SHARED dist9(70), v91(70), v92(70), mass9(70), ax1&(70), ax2&(70)' test 9
DIM SHARED disktype, dzdisk, shape, dmax, dblg  'DISK

CONST ESC = 27, ENTER = 13
CONST pi = 3.141592653589#
CONST lightyear = 9460000000000#
Title$ = "Sun Radius Calculation"

'  READDATA                             'Convert SUNRAD.DB to SUNRAD.BAS

RESTORE s20:
READ nnr, nnz, ndalpha, radsun, eradsun
FOR i = 0 TO 70: READ dist9(i), v91(i), v92(i), mass9(i): NEXT i
FOR i = 0 TO 70: READ ax1&(i), ax2&(i): NEXT i

test% = 1
savedata = 0                        ' 1 = create your own curve
calib = 1                           ' calibration
ddisk = 2000                        ' height disk
nr = 10: dalpha = 45: nz = 1
spvel = 250                         ' setpoint velocity
shape = .4                          ' shape disk 1 = flat  0 = hilly
disktype = 2                        ' disk type

s0:

SCREEN 12

s1:
CLS : COLOR 15
PRINT "1 = # r"; TAB(15); nr; TAB(22); "2 = # z"; TAB(37); nz; TAB(42); "3 = d alpha  "; dalpha; TAB(62); "4 = z disk "; ddisk
PRINT USING "5 = shape disk #.#"; shape;
PRINT TAB(22); "6 = calibration"; calib; TAB(42); "7 = save data"; savedata; TAB(62); "8 = sp vel "; spvel
PRINT "9 = disk type "; disktype
COLOR 14: PRINT "10 = test #   "; test%
COLOR 15: PRINT "0 = execute test "; TAB(40); "else = terminate"
INPUT "parameter"; par
IF par <> 0 THEN
  IF par > 0 AND par <= 10 THEN INPUT "value "; value
  SELECT CASE par
  CASE 1
    nr = value
  CASE 2
    nz = value
  CASE 3
    dalpha = value
  CASE 4
    ddisk = value
  CASE 5
    shape = value
  CASE 6
    calib = value
  CASE 7
    savedata = value
  CASE 8
    spvel = value
  CASE 9
    disktype = value
  CASE 10
    test% = value
  CASE ELSE
    END
END SELECT
  IF par >= 1 AND par <= 9 THEN test% = 1
  IF par <> 7 THEN savedata = 1
GOTO s1
END IF

CLS
 
  dblg = 7500 * lightyear            ' radius bulge
  dsun = 25000 * lightyear           ' distance sun
  dmax = 60000 * lightyear           ' radius outer visible galaxy
  dmax1 = 70000 * lightyear          ' radius outer galaxy
  dzdisk = ddisk * lightyear         ' height disk
  dzdisk = dzdisk / 2                ' half height disk
  dsuncal = dsun

SELECT CASE test%

CASE IS = 1
  G = 6.67D-20
  m0 = 2D+30 * 110000000000#         ' Galaxy  mass in kg
  m1 = 2D+30                         ' Sun
  year = 365.25 * 24 * 60 * 60
  scren% = 12: SCREEN scren%
  ychrmax = 29
  PRINT "distance"; TAB(21); "v km/sec"; TAB(40); "rev time in million years"
  ddsun = 5000 * lightyear           ' step size distance
  IF savedata = 1 THEN ddsun = ddsun / 5

' Calculation mass in the center

FOR dsun1 = ddsun TO dmax1 STEP ddsun
  dist = dsun1
  mm01 = m0 + m1
  r0 = dist * m1 / mm01
  r1 = dist - r0
  vr0 = SQR(r0 * m1 * G) / dist
  vr1 = SQR(r1 * m0 * G) / dist          ' meter/sec
  IF savedata = 1 THEN i = dsun1 / ddsun - 1: dist9(i) = dsun1: v91(i) = vr1
  IF dist = dsun THEN COLOR 7 ELSE COLOR 15
  dll = dist / lightyear
  IF dll < 52000 AND dll MOD 5000 = 0 THEN PRINT dll, vr1, 2 * pi * r1 / (vr1 * year * 1000000)
NEXT dsun1

masgal0 = m0                 ' total mass inner galaxy
dmasgal = 0
calib1 = calib               ' calibration

PRINT "distance"; TAB(13); "mass < dist"; TAB(29); "mass correct"; TAB(48); "v km/sec";
PRINT TAB(60); "ax bulge"; TAB(72); "ax disk"

cal1:
masgal = masgal0 - dmasgal                 ' total mass inner galaxy
volcent = 4 / 3 * pi * dblg * dblg * dblg
densgal = masgal / volcent
dd = dblg / nr: dphi = dalpha              ' radius bulge / nr
nrend = dmax / dblg * nr                   ' based on inner maximum
accuz = nz

' disk calculation

FOR dsun1 = 1 * ddsun TO dmax1 STEP ddsun          ' modified    dmax = ddsun
IF calib1 = 1 THEN dsun1 = dsuncal
  denscor = .6                          ' disk density correction
  voldisk = 0: massdisk = 0: massdisk1 = 0: axdisk = 0

  FOR r = nr * 0 + 1 TO nrend
    r1 = (r - .5) * dd
    a$ = INKEY$: IF a$ = CHR$(ESC) THEN GOTO s10
    FOR phi = 0 TO 180 - dphi STEP dphi
      phi1 = (phi + dphi / 2) * pi / 180
      x = r1 * COS(phi1): y = r1 * SIN(phi1)
      dx = dsun1 - x:
      dzdiskcor = DISK(r1)
'      dzdiskcor = (dzdisk / dmax) * SQR(dmax * dmax - r1 * r1) * ((shape - 1) / dmax * r1 + 1)'ellipse
      IF dzdiskcor > 0 THEN
        dvol = pi * dd * dphi / 180 * dzdiskcor * r1
        dm = dvol * densgal * denscor
        ddzdiskcor = dzdiskcor / accuz: ddvol = dvol / accuz: ddm = ddvol * densgal * denscor
        FOR z = 1 TO accuz
          z1 = (z - .5) * ddzdiskcor
          rd = SQR(z1 * z1 + dx * dx + y * y)
          da = ddm / (rd * rd)
          dax = da * dx / rd        'dblg
          axdisk = axdisk + 4 * dax
        NEXT z
        voldisk = voldisk + 4 * dvol
        massdisk = massdisk + 4 * dm
      END IF
    NEXT phi
    IF r1 < dsun1 THEN massdisk1 = massdisk
  NEXT r

'  central part of galaxy calculation

  IF dsun1 < dblg THEN
  axcent = 0: masscent = 0: masscent1 = 0: volcent1 = 0
  FOR r = 1 TO nr
    r1 = (r - .5) * dd
    a$ = INKEY$: IF a$ = CHR$(ESC) THEN GOTO s10
    FOR phi = 0 TO 180 - dphi STEP dphi
      phi1 = (phi + dphi / 2) * pi / 180
      x = r1 * COS(phi1): y = r1 * SIN(phi1)
      dx = dsun1 - x:
      z = SQR(dblg * dblg - r1 * r1)         ' pos height of galaxy
      dvol = pi * dd * dphi / 180 * z * r1
      dm = dvol * densgal:
      dz = z / accuz: ddvol = dvol / accuz
      ddm = ddvol * densgal
      FOR z = 1 TO accuz
        z1 = (z - .5) * dz
        rd = SQR(z1 * z1 + dx * dx + y * y)
        da = ddm / (rd * rd)
        dax = da * dx / rd
        dax1& = 4 * dax
        axcent = axcent + dax1&
        masscent = masscent + 4 * ddm
        volcent1 = volcent1 + 4 * ddvol
      NEXT z
    NEXT phi
    IF r1 < dsun1 THEN masscent1 = masscent
  NEXT r
  ELSE
    axcent = masgal / (dsun1 * dsun1)                'ax central galaxy
  END IF
  masgalcor = (axdisk + axcent) * dsun1 * dsun1
  m0 = masgalcor:
  dist = dsun1
  mm01 = m0 + m1
  r0 = dist * m1 / mm01
  r1 = dist - r0
  vr0 = SQR(r0 * m1 * G) / dist
  vr1 = SQR(r1 * m0 * G) / dist          ' meter/sec
  IF savedata = 1 THEN
     i = dsun1 / ddsun - 1:
     dist9(i) = dsun1: v92(i) = vr1: mass9(i) = massdisk1 + masscent1
     ax1&(i) = axcent: ax2&(i) = axdisk
  END IF
  year = 365.25 * 24 * 60 * 60
  IF dsun1 = dsun THEN COLOR 7 ELSE COLOR 15
  PRINT dsun1 / lightyear; TAB(12);
  PRINT USING "##.####^^^^^"; massdisk1 + masscent1;
  PRINT USING "##.####^^^^^"; TAB(28); masgalcor; TAB(48);
  PRINT USING "####.#"; vr1;
  PRINTTAB 68, INT(axcent)
  PRINTTAB 80, INT(axdisk)

  IF calib1 = 1 THEN
    masssave = masgalcor
    dvr1 = vr1 - spvel: IF ABS(dvr1) < 1 THEN calib1 = 0: GOTO cal1
    ddmasgal = (vr1 - spvel) * masgal0 / spvel
    IF ddmasgal > masgal * .2 THEN ddmasgal = .2 * masgal
    dmasgal = dmasgal + ddmasgal: GOTO cal1
  END IF
NEXT dsun1
PRINT TAB(7); "mass bulge"; TAB(31); "mass disk"; TAB(49); "total mass galaxy"
PRINT masscent; TAB(25); massdisk; TAB(49); masscent + massdisk
pc3 = 3.26 * 3.26 * 3.26        'par sec
lightyear3 = lightyear * lightyear * lightyear
volly1 = volcent1 / lightyear3: massM0 = masscent / m1
volpc1 = volly1 / pc3
PRINT "ly v "; volly1; "m "; massM0; massM0 / volly1
PRINT "pc v "; volpc1; "m "; massM0; massM0 / volpc1
volly = (volcent1 + voldisk) / lightyear3: massM0 = (masscent + massdisk) / m1
volpc = volly / pc3:
PRINT "ly v "; volly; "m "; massM0; massM0 / volly
PRINT "pc v "; volpc; "m "; massM0; massM0 / volpc

IF savedata = 1 THEN savedata = 1

CASE IS = 2

SCREEN scren%: ychrmax = 29: ychrmax = ychrmax - 3
vmax = 900                    ' max display speed
dmax = 60000

FOR i = 1 TO 69
  COLOR 7
  LOCATE 1, 1:
' PRINT i, dist9(i) / lightyear / 100, v91(i) / 2
  LINE (dist9(i - 1) * 600 / lightyear / dmax, 479 - v91(i - 1) * 450 / vmax)-(dist9(i) * 600 / lightyear / dmax, 479 - v91(i) * 450 / vmax)
NEXT i
FOR i = 1 TO 69
  COLOR 15
  LOCATE 1, 1:
' PRINT i, dist9(i) / lightyear / 100, v92(i) / 2
  LINE (dist9(i - 1) * 600 / lightyear / dmax, 479 - v92(i - 1) * 450 / vmax)-(dist9(i) * 600 / lightyear / dmax, 479 - v92(i) * 450 / vmax)
NEXT i
FOR i = 0 TO dmax STEP dmax / 12
  LINE (i * 600 / dmax, 479 - 1)-(i * 600 / dmax, 479 - 10)
NEXT i
FOR i = 0 TO vmax STEP vmax / 9
  LINE (1, 479 - i * 450 / vmax)-(10, 479 - i * 450 / vmax)
NEXT i
i3& = 6 * vmax / 9: LOCATE 11, 2: PRINT i3&;
i3& = 3 * vmax / 9: LOCATE 21, 2: PRINT i3&;
i3& = 2 * dmax / 12: LOCATE 29, 11: PRINT i3&;
i3& = 5 * dmax / 12: LOCATE 29, 30: PRINT i3&;
i3& = 10 * dmax / 12: LOCATE 29, 60: PRINT i3&;
i3& = dmax: LOCATE 29, 73: PRINT i3&;
LOCATE 12, 10: PRINT "A"
LOCATE 20, 60: PRINT "B"
LOCATE 1, 25: PRINT "GALAXY ROTATION CURVE"
LOCATE 2, 25: PRINT "Vertical speed in km/sec"
LOCATE 3, 25: PRINT "Horizontal distance in lightyear"
IF savedate = 1 THEN COLOR 4: LOCATE 4, 50: PRINT "New data"
COLOR 7
LOCATE 5, 20: PRINT "A = mass of galaxy concentrated in one point"
LOCATE 6, 20: PRINT "B = mass of galaxy distributed in bulge and disk"
COLOR 15

CASE IS = 3
 
  COLOR 15
  dblg = 7500               ' radius bulge
  scren% = 12: SCREEN scren%: ychrmax = 29
  PRINT "distance"; TAB(12); "v km/sec"; TAB(24); "v km/sec";
  PRINT TAB(36); "mass < dist"; TAB(50); "ax bulge"; TAB(61); "ax disk"; TAB(71); "hgt disk";
  PRINT TAB(12); "in center"; TAB(24); "mass = 3d"

  FOR i = 0 TO 8
    dzdiskcor = DISK(dist9(i))
    PRINT dist9(i) / lightyear; TAB(12);
    PRINT USING "#####.##"; v91(i); TAB(24); v92(i); TAB(36);
    PRINT USING "##.###^^^^^"; mass9(i);
    PRINT USING "########"; TAB(50); ax1&(i); TAB(60); ax2&(i); TAB(70); dzdiskcor * 2 / lightyear
  NEXT i
  FOR i = 9 TO 69 STEP 5
    dzdiskcor = DISK(dist9(i))
    IF dist9(i) = dsun THEN COLOR 7 ELSE COLOR 15
    PRINT dist9(i) / lightyear; TAB(12);
    PRINT USING "#####.##"; v91(i); TAB(24); v92(i); TAB(36);
    PRINT USING "##.###^^^^^"; mass9(i);
    PRINT USING "########"; TAB(50); ax1&(i); TAB(60); ax2&(i); TAB(70); dzdiskcor * 2 / lightyear
  NEXT i
  PRINT " "
  PRINT "distance Sun   = "; dsun / lightyear; "lightyear"
  PRINT "height disk    =  "; ddisk; "lightyear"
  PRINT "diameter bulge = "; 2 * dblg; "lightyear"

CASE ELSE
END
END SELECT
s99:

s10:
COLOR 14
test% = test% + 1
LOCATE ychrmax, 20: PRINT "NEXT TEST ? ";

DO: a$ = INKEY$: LOOP UNTIL a$ <> ""
GOTO s0

nr = 75: nz = 20: dalpha = 3

s20:
DATA  75,20,3,700000,280000
DATA  9460000000000000,1245.45,44.63,3.270117566173389D+39
DATA  1.892D+16,880.67,89.18000000000001,1.290907254913156D+40
DATA  2.838D+16,719.0599999999999,133.65,2.839653527498713D+40
DATA  3.784D+16,622.72,178.08,4.881157529596307D+40
DATA  4.73D+16,556.98,222.49,7.270873045718019D+40
DATA  5.676D+16,508.45,266.86,9.782473478145394D+40
DATA  6.622D+16,470.73,311.16,1.201297969642174D+41
DATA  7.568D+16,440.33,324.08,1.287975879217029D+41
DATA  8.514D+16,415.15,307.95,1.325442205843199D+41
DATA  9.46D+16,393.84,294.92,1.36675331807844D+41
DATA  1.0406D+17,375.51,284.32,1.411779971203134D+41
DATA  1.1352D+17,359.53,275.67,1.460390249048566D+41
DATA  1.2298D+17,345.42,268.63,1.512449680338971D+41
DATA  1.3244D+17,332.86,262.94,1.567821351493109D+41
DATA  1.419D+17,321.57,258.38,1.626366015932017D+41
DATA  1.5136D+17,311.36,254.8,1.687942199914021D+41
DATA  1.6082D+17,302.06,252.07,1.75240630489078D+41
DATA  1.7028D+17,293.55,250.07,1.819612706348421D+41
DATA  1.7974D+17,285.72,248.7,1.889413849065261D+41
DATA  1.892D+17,278.49,247.89,1.961660338681723D+41
DATA  1.9866D+17,271.78,247.56,2.03620102943703D+41
DATA  2.0812D+17,265.53,247.66,2.112883107881515D+41
DATA  2.1758D+17,259.69,248.13,2.191552172320152D+41
DATA  2.2704D+17,254.22,248.92,2.27205230768161D+41
DATA  2.365D+17,249.09,250,2.354226155435462D+41
DATA  2.4596D+17,244.25,251.32,2.43791497809629D+41
DATA  2.5542D+17,239.68,252.85,2.522958717752682D+41
DATA  2.6488D+17,235.36,254.56,2.609196047940313D+41
DATA  2.7434D+17,231.27,256.42,2.696464418035131D+41
DATA  2.838D+17,227.38,258.41,2.784600089168155D+41
DATA  2.9326D+17,223.69,260.51,2.873438160452532D+41
DATA  3.0272D+17,220.16,262.7,2.962812584053532D+41
DATA  3.1218D+17,216.8,264.96,3.052556167311657D+41
DATA  3.2164D+17,213.59,267.28,3.14250055972962D+41
DATA  3.311D+17,210.52,269.63,3.232476222133004D+41
DATA  3.4056D+17,207.57,272.01,3.322312374682558D+41
DATA  3.5002D+17,204.75,274.4,3.411836919607722D+41
DATA  3.5948D+17,202.03,276.8,3.500876333492917D+41
DATA  3.6894D+17,199.43,279.18,3.589255522599579D+41
DATA  3.784D+17,196.92,281.55,3.676797632932739D+41
DATA  3.8786D+17,194.5,283.9,3.763323804409064D+41
DATA  3.9732D+17,192.17,286.21,3.848652855313615D+41
DATA  4.0678D+17,189.93,288.48,3.932600878915062D+41
DATA  4.1624D+17,187.75,290.7,4.014980728127412D+41
DATA  4.257D+17,185.66,292.86,4.095601355685734D+41
DATA  4.3516D+17,183.63,294.96,4.174266965224073D+41
DATA  4.4462D+17,181.66,296.99,4.250775910948447D+41
DATA  4.5408D+17,179.76,298.94,4.324919257061989D+41
DATA  4.6354D+17,177.92,300.8,4.396478867213614D+41
DATA  4.73D+17,176.13,302.58,4.465224829281687D+41
DATA  4.8246D+17,174.39,304.25,4.530911913816276D+41
DATA  4.9192D+17,172.71,305.82,4.593274580669151D+41
DATA  5.0138D+17,171.07,307.25,4.652019716247325D+41
DATA  5.1084D+17,169.48,308.55,4.706815645690882D+41
DATA  5.203D+17,167.93,309.67,4.757274639985193D+41
DATA  5.2976D+17,166.43,310.58,4.802923102336838D+41
DATA  5.3922D+17,164.96,311.14,4.843145654856261D+41
DATA  5.4868D+17,163.53,311.07,4.877063911438726D+41
DATA  5.5814D+17,162.14,309.38,4.903197649195705D+41
DATA  5.676D+17,160.78,303.83,4.917484478725111D+41
DATA  5.7706D+17,159.46,294.74,4.917484478725111D+41
DATA  5.8652D+17,158.17,286.2,4.917484478725111D+41
DATA  5.9598D+17,156.91,279.2,4.917484478725111D+41
DATA  6.0544D+17,155.68,273.34,4.917484478725111D+41
DATA  6.149D+17,154.47,268.24,4.917484478725111D+41
DATA  6.2436D+17,153.3,263.7,4.917484478725111D+41
DATA  6.3382D+17,152.15,259.59,4.917484478725111D+41
DATA  6.4328D+17,151.03,255.82,4.917484478725111D+41
DATA  6.5274D+17,149.93,252.33,4.917484478725111D+41
DATA  6.622D+17,148.86,249.07,4.917484478725111D+41
DATA  0,0,0,0
DATA  3022808,134902,6039896,262353,9058515,378740,12079064,486742
DATA  15102325,588338,18126536,684590,21145140,776200,19943896,863688
DATA  15752767,947454,12757005,1027810,10541840,1105007,8857501,1179245
DATA  7546895,1250687,6507071,1319465,5668250,1385690,4981771,1449453
DATA  4412855,1510828,3936112,1569878,3532653,1626656,3188194,1681207
DATA  2891766,1733571,2634837,1783780,2410690,1831864,2213974,1877850
DATA  2040391,1921762,1886450,1963621,1749295,2003449,1626572,2041264
DATA  1516325,2077085,1416919,2110929,1326977,2142813,1245334,2172753
DATA  1171001,2200764,1103130,2226860,1040993,2251057,983962,2273366
DATA  931493,2293800,883111,2312372,838403,2329090,797006,2343966
DATA  758601,2357007,722907,2368220,689674,2377609,658681,2385176
DATA  629731,2390922,602649,2394841,577277,2396926,553474,2397160
DATA  531113,2395518,510081,2391963,490274,2386438,471598,2378855
DATA  453970,2369077,437312,2356876,421554,2341856,406633,2323243
DATA  392490,2299271,379072,2265029,366331,2204879,354222,2084259
DATA  342703,1914436,331737,1762115,321289,1639800,311327,1538833
DATA  301822,1452602,292745,1377156,284071,1310031,275778,1249578
DATA  267842,1194629,260244,1144318
DATA  0,0

FUNCTION DISK (r)
'                                                           DISK
' zdisk = height of disk / 2
IF r > dmax THEN
  rcor = 0
ELSE
  SELECT CASE disktype
  CASE 1
    rcor = dzdisk * (r * (1 - shape) + shape * dblg - dmax) / (dblg - dmax)
    IF rcor > dzdisk THEN rcor = dzdisk
  CASE 2
    rcor = (dzdisk / dmax) * SQR(dmax * dmax - r * r) * ((shape - 1) / dmax * r + 1) 'ellipse
  END SELECT
END IF
DISK = rcor
END FUNCTION

SUB PRINTTAB (posx, num)
IF num >= 10000000 THEN l = 10: GOTO p1
IF num >= 1000000 THEN l = 9: GOTO p1
IF num >= 100000 THEN l = 8: GOTO p1
IF num >= 10000 THEN l = 7: GOTO p1
IF num >= -10000 THEN l = 6: GOTO p1
IF num >= -100000 THEN l = 7: GOTO p1
IF num >= -1000000 THEN l = 8: GOTO p1
l = 9
p1: PRINT TAB(posx - l); num;

END SUB

SUB READDATA
'                                                                    READDATA
DIM mdb(10), sdb(10), fdb(10), rdb(10)
DIM zm(7, 7), z(7), zz(7), st(14)           ' GET COEF parameters
DIM zvenus(7), zall(7)                      ' GET COEF results
DIM ax1(70), ax2(70)
data1$ = "DATA "
filenm$ = "C:\NOW\FIG\sunrad.db  "
ioerr% = 0
    OPEN filenm$ FOR INPUT AS #1
    IF ioerr% > 0 THEN EXIT SUB
    INPUT #1, nnr, nnz, ndalpa, radsun, eradsun
    IF ioerr% > 0 THEN EXIT SUB
    FOR i = 0 TO 10
      INPUT #1, rdb(i), sdb(i), mdb(i), fdb(i)
    NEXT i
    FOR i = 0 TO 7: INPUT #1, zvenus(i): NEXT i
    FOR i = 0 TO 7: INPUT #1, zall(i): NEXT i
    FOR i = 0 TO 70: INPUT #1, dist9(i), v91(i), v92(i), mass9(i): NEXT i
    FOR i = 0 TO 70: INPUT #1, ax1&(i), ax2&(i): NEXT i
    CLOSE

ioerr% = 0
filenm$ = "C:\INTERNET\NETSCAPE\HTMLED\sunrad.bas  "
' filenm$ = "C:\NICK\HTMLED\sunrad.bas  "
PRINT filenm$

    OPEN filenm$ FOR OUTPUT AS #1
    IF ioerr% > 0 THEN EXIT SUB
    WRITE #1, data1$, nnr, nnz, ndalpa, radsun, eradsun
    IF ioerr% > 0 THEN EXIT SUB
    FOR i = 0 TO 70:
      vst1 = INT(v91(i) * 100) / 100
      vst2 = INT(v92(i) * 100) / 100
      WRITE #1, data1$, dist9(i), vst1, vst2, mass9(i)
    NEXT i
    FOR i = 0 TO 67 STEP 4
      WRITE #1, data1$, ax1&(i), ax2&(i), ax1&(i + 1), ax2&(i + 1), ax1&(i + 2), ax2&(i + 2), ax1&(i + 3), ax2&(i + 3)
    NEXT i
    i = 68: WRITE #1, data1$, ax1&(i), ax2&(i), ax1&(i + 1), ax2&(i + 1)
    i = 70: WRITE #1, data1$, ax1&(i), ax2&(i)
    CLOSE

END SUB

